using System;
using System.Collections.Generic;
using System.Runtime.Serialization.Formatters.Binary;
using System.IO;
using System.Runtime.Serialization;
using System.Reflection;

namespace BinarySerialization
{
    public static class BinarySerializer
    {
        public static void Serialize(object obj, string filePath)
        {
            IFormatter f = new BinaryFormatter();

            FileStream fs = new FileStream(Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location)
                + Path.DirectorySeparatorChar + Path.DirectorySeparatorChar + filePath, FileMode.Create);

            f.Serialize(fs, obj);
            fs.Dispose();
        }

        public static object Deserialize(string filePath)
        {
            IFormatter f = new BinaryFormatter();
            
            using (FileStream fs = new FileStream(Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location)
                + Path.DirectorySeparatorChar + Path.DirectorySeparatorChar + filePath, FileMode.Open))

            return f.Deserialize(fs) as object;
        }

    }
}
