﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;
using GameEngine.Helpers;
using Microsoft.Xna.Framework;
using GameEngine.Xml;

namespace GameContentPipeline
{
    [ContentTypeWriter]
    public class TilesetWriter : ContentTypeWriter<TilesetWrapper>
    {
        protected override void Write(ContentWriter output, TilesetWrapper value)
        {
            output.WriteObject(value.Tilesets);
            output.WriteObject(value.Tiles);
            output.WriteObject(value.SpecialTiles);
        }

        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            return typeof(TilesetReader).AssemblyQualifiedName;
        }
    }
}
