﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace GameEngine.Animation
{
    public struct BoneManipulator
    {
        public string BoneName;
        public Matrix Transform;
        public bool Replace;

        public BoneManipulator(string boneName, Matrix transform) : this(boneName, transform, false) { }
        public BoneManipulator(string boneName, Matrix transform, bool replace)
        {
            this.BoneName = boneName;
            this.Transform = transform;
            this.Replace = replace;
        }
    }
}
