using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using GameEngine.Cameras;
using GameEngine.Xml;
using GameEngine.Helpers;

namespace GameEngine
{
    public class DrawInfo
    {
        public GraphicsDevice GraphicsDevice;
        public Camera Camera { get; set; }
        public Camera[] AllCameras { get; set; }

        public List<IPointLight> PointLights { get; private set; }
        public List<IPointLight> UpdatePointLights { get; private set; }

        public List<ModelNode> Models = new List<ModelNode>();
        public List<GeometryDrawInfo> Gdis = new List<GeometryDrawInfo>();

        public bool UpdateOBBs { get; set; }

        // lights
        // stuff
        
        public DrawInfo()
        {
            PointLights = new List<IPointLight>();
            UpdatePointLights = new List<IPointLight>();
        }
    }
}
