﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework;

namespace GameEngine
{
    public static class EngineFX
    {
        public const string PolyWall = @"enginefx\PolyWall";
        public const string Primitives = @"enginefx\Primitives";
        public const string PointLight = @"enginefx\PointLight";
        public const string PointLightSphere = @"enginefx\sphere2";
        public const string RenderGBuffer = @"enginefx\RenderGBuffer";
        public const string DirectionalLight = @"enginefx\DirectionalLight";
        public const string ClearGBuffer = @"enginefx\ClearGBuffer";
        public const string CombineFinal = @"enginefx\CombineFinal";

        public static bool InEditor = false;

        public enum PolyWallTechniques
        {
            Attenuation = 0,
            Black = 1

        }
    }
}
